#ifndef SCHEDULING_DATA_H
#define SCHEDULING_DATA_H

// Copyright (c) The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.

// Authors: Malolan Chetlur             mal@ececs.uc.edu
//          Jorgen Dahl                 dahlj@ececs.uc.edu
//          Dale E. Martin              dmartin@cliftonlabs.com
//          Radharamanan Radhakrishnan  ramanan@ececs.uc.edu
//          Dhananjai Madhava Rao       dmadhava@ececs.uc.edu
//          Philip A. Wilsey            phil.wilsey@uc.edu

#include "warped.h"
#include "ReceiverQueueContainer.h"

class SchedulingData {
 public:

  SchedulingData() : scheduleList(new vector<ScheduleListContainer*>),
    popHeapFlag(false),
    makeHeapFlag(false) {
  };

  ~SchedulingData() {
    vector<ScheduleListContainer*>::iterator begin_iter = scheduleList->begin();
    vector<ScheduleListContainer*>::iterator end_iter = scheduleList->end();
    while(begin_iter != end_iter) {
      ScheduleListContainer* ptr = *(begin_iter);
      begin_iter++;
      delete ptr;
    }
    delete scheduleList;
  }

  void PopHeapFlag(bool value) { popHeapFlag = value;}
  bool PopHeapFlag() { return popHeapFlag;}

  void MakeHeapFlag(bool value) { makeHeapFlag = value;}
  bool MakeHeapFlag() { return makeHeapFlag;}

  vector<ScheduleListContainer*>* scheduleList;

 private:

  bool popHeapFlag;
  bool makeHeapFlag;
};

#endif

